using JiShe.CollectBus.Common.Enums;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Contracts;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;
using JiShe.CollectBus.Protocol.T37612012.Appendix;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.IotSystems.Ammeters;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_0DH
{
    /// <summary>
    /// 5.13.2.4.68 F89：测量点 A相电压曲线
    /// </summary>
    public class AFN13_F89_Analysis : IAnalysisStrategy<TB3761>
    {

        private readonly ILogger<AFN13_F89_Analysis> _logger;
        private readonly AnalysisStrategyContext _analysisStrategyContext;
        private readonly DataStorage _dataStorage;
        public AFN13_F89_Analysis(ILogger<AFN13_F89_Analysis> logger, AnalysisStrategyContext analysisStrategyContext, DataStorage dataStorage)
        {
            _logger = logger;
            _analysisStrategyContext = analysisStrategyContext;
            _dataStorage = dataStorage;
        }

        public async Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.UnitData?.HexMessageList);

                List<string> datas = await AnalysisDataUnitAsync(input.UnitData.HexMessageList);
                int density = Convert.ToInt32(Enum.GetName(typeof(DensityEnums), Convert.ToInt32(datas[1]))!.Split('_')[1]);//密度-间隔分钟数,
                string dataType = $"{input.AFN_FC.AFN.HexToDecStr().PadLeft(2, '0')}_{input.DT.Fn}";

                List<AnalysisBaseDto<decimal>> data = datas.GenerateFinalResultTd_c(3, density, dataType, "A相电压曲线");
                if (data.Count > 0)
                {
                    // 查询电表信息
                    AmmeterInfo ammeterInfo = await _dataStorage.GetMeterInfoAsync(data[0].MeterType.ToString(), "15");
                    if (ammeterInfo != null)
                    {
                        data.ForEach(item =>
                        {
                            item.ProjectId = ammeterInfo.ProjectID;
                            item.MeterId = ammeterInfo.MeterId;
                            item.DatabaseBusiID = ammeterInfo.DatabaseBusiID;
                            item.MeterAddress = ammeterInfo.AmmerterAddress;
                        });
                    }
                }
                UnitDataAnalysis<List<AnalysisBaseDto<decimal>>> unitDataAnalysis = new UnitDataAnalysis<List<AnalysisBaseDto<decimal>>>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    MSA = input.A.A3!.D1_D7!,
                    PSEQ = input.SEQ.PSEQ,
                    Data = data,
                    HexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    TimeDensity = density,//密度-间隔分钟数,
                    DensityUnit = DensityUnit.Minute,
                    ReceivedTime = input.ReceivedTime
                };
                await _dataStorage.SaveMultipleDataToIotDbAsync<decimal>(unitDataAnalysis);
                result?.Invoke(unitDataAnalysis);
                return await Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"0D_89解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");
                return await Task.FromResult(false);
            }
        }
       
        private async Task<List<string>> AnalysisDataUnitAsync(List<string> hexMessageList)
        {
            List<string> values = new List<string>();
            values.AddRange(hexMessageList.GetReadTimeTd_c(4, 7));
            int.TryParse(values[values.Count - 1], out int n);

            for (int i = 0; i < n; i++)
            {
                var arr = hexMessageList.GetRange(11 + (i * 2), 2);
                var errorCode = arr.CheckErrorCode();
                if (errorCode != null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A7), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    });
                }
            }
            return values;
        }
    }
}
